package org.syzygy.mp3.server;

import java.util.Date;
import java.util.Calendar;
import java.text.SimpleDateFormat;

public final class StringUtil
{
    private StringUtil()
    {
    }

    public static String getDateAsString(Date date)
    {
        Calendar when = Calendar.getInstance();
        Calendar then = Calendar.getInstance();
        then.setTime(date);
        when.add(Calendar.DAY_OF_MONTH, -1);
        if (when.before(then)) { // less than 1 day
            SimpleDateFormat df = new SimpleDateFormat("HH:mm");
            return df.format(then.getTime());
        }
        when.add(Calendar.DAY_OF_MONTH, -6);
        if (when.before(then)) { // less than 1 week
            SimpleDateFormat df = new SimpleDateFormat("EEE");
            return df.format(then.getTime());
        }
        when.add(Calendar.DAY_OF_MONTH, 7);
        when.add(Calendar.YEAR, -1);
        if (when.before(then)) { // less than 1 year
            SimpleDateFormat df = new SimpleDateFormat("dd-MMM");
            return df.format(then.getTime());
        }
        // older than a year
        SimpleDateFormat df = new SimpleDateFormat("dd/MM/yy");
        return df.format(then.getTime());
    }
    
    /**
     * Munges a string by stripping it of everything but letters or
     * digits, removing common words and converting it to lower-case.
     */
    public static String munge(String str)
    {
        StringBuffer s = new StringBuffer();
        int len = str.length();
        for (int i = 0; i < len; i++) {
            char c = str.charAt(i);
            if (Character.isLetterOrDigit(c) || Character.isWhitespace(c))
                s.append(Character.toLowerCase(c));
            else if (c == '_')
                s.append(' ');
        }
        String munged = s.toString();
        munged = munged.replaceAll("the ", "");
        munged = munged.replaceAll("^a ", "");
        munged = munged.replaceAll(" a ", "");
        munged = munged.replaceAll(" and ", " ");
        munged = munged.replaceAll(" of ", " ");
        munged = munged.replaceAll("[\\s]+", " ");
        return munged;
    }
}
